package cinema;

public class Poltrona
{
	String prenotante = null;

	/**
	* Test di prenotazione della poltrona. Ritorna il nome del prenotante o null
	* se e' libera.
	*/
	public String prenotata()
	{
		return prenotante;
	}

	/**
	* Test di poltrona libera. Ritorna true se e' libera da prenotazione.
	*/
	public boolean isLibera()
	{
		return (prenotata() == null);
	}

	/**
	* Prenota la poltrona a nome ilPrenotante. Se la poltrona era gia' occupata,
	* l'azione fallisce. Ritorna true in caso di successo, false altrimenti.
	*/
	public boolean prenota(String ilPrenotante)
	{
		if(!isLibera())
		{
			return false;
		}
		prenotante = ilPrenotante;
		return true;
	}

	/**
	* Cancella la prenotazione della poltrona. Se la poltrona non era prenotata
	* al nome de ilPrenotante, l'azione fallisce; significa sia non prenotata
	*	affatto, sia prenotata ad un nome diverso da ilCancellante. Ritorna true
	*	in caso di successo, false altrimenti.
	*/
	public boolean cancellaPrenotazione(String ilCancellante)
	{
		if(! ilCancellante.equals(prenotata()))
		{
			return false;
		}
		prenotante = null;
		return true;
	}

	/**
	* Fornisce la versione stringhificata dell'oggetto Poltrona. L'informazione
	* contenuta e' lo stato di prenotazione e il nome dell'eventuale prenotante.
	*/
	public String toString()
	{
		if(prenotante == null)
		{
			return "Poltrona Libera";
		}
		return "Poltrona prenotata da " + prenotante;
	}
}
