package maps;

import java.util.*;
import java.io.*;

public class MappaStudenti
{
	Map<String, List<Studente>> mappaPerNome = new HashMap<String, List<Studente>>();

	public static void main(String[] argv)
	{
		(new MappaStudenti()).exec(argv);
	}

	public void exec(String[] argv)
	{
		BufferedReader br = null;

		try
		{
			br = new BufferedReader(new FileReader(argv[0]));
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
			System.exit(1);
		}

		String line = null;
		try
		{
			while( (line = br.readLine()) != null)
			{
				String nome = line;
				String cognome = br.readLine();
				int matricola = Integer.parseInt(br.readLine());

				Studente s = new Studente(nome, cognome, matricola);
				List<Studente> tmp = mappaPerNome.get(nome);
				if(tmp == null)
				{
					tmp = new LinkedList<Studente>();
					mappaPerNome.put(nome, tmp);
				}
				tmp.add(s);
			}
			br.close();
			System.out.println(mappaPerNome);
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}

		br = new BufferedReader(new InputStreamReader(System.in));
		while(true)
		{
			System.out.print("Nome studente? > ");
			try
			{
				line = br.readLine();
			}
			catch(IOException ioe)
			{
				ioe.printStackTrace();
				break;
			}
			if(line == null || line.equals(""))
			{
				break;
			}
			System.out.println(mappaPerNome.get(line));
		}
	}
}
