package radiazioni;

import java.util.*;
import java.io.*;

public class BaseArtica
{
	List<Misurazione>[][] dati;

	//Comparator<Misurazione> c1, c2;
	Map<String, Comparator<Misurazione>> comparatori;

	public BaseArtica(int x, int y)
	{
		dati = (List<Misurazione>[][])(new List[x][y]);
		comparatori = new HashMap<String, Comparator<Misurazione>>();
		comparatori.put("giorno", new ComparaPerGiorno());
		comparatori.put("valore", new ComparaPerValore());
	}

	public BaseArtica()
	{
		this(100, 100);
	}

	public void exec()
	{
		Scanner stdin = new Scanner(System.in);

		while(stdin.hasNextLine())
		{
			String comando = stdin.nextLine();

			if(comando.equalsIgnoreCase("exit"))
			{
				break;
			}
			else if(comando.equalsIgnoreCase("leggi"))
			{
				leggi(stdin);
			}
			else if(comando.equalsIgnoreCase("elenco"))
			{
				elenco(stdin);
			}
			else if(comando.equalsIgnoreCase("minimo"))
			{
				minimo(stdin);
			}
			else
			{
				System.out.println("Non conosco il comando <" + comando + ">");
			}
		}
	}

	void leggi(Scanner stdin)
	{
		System.out.print("Nome file? > ");
		String nome = stdin.nextLine();

		Scanner fileDati = null;
		try
		{
			fileDati = new Scanner(new FileInputStream(nome));
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
			return;
		}

		while(fileDati.hasNextLine())
		{
			int x = Integer.parseInt(fileDati.nextLine());
			int y = Integer.parseInt(fileDati.nextLine());
			short giorno = Short.parseShort(fileDati.nextLine());
			double val = Double.parseDouble(fileDati.nextLine());
			Misurazione m = new Misurazione(giorno, val);

			System.out.println(x + " " + y + " " + m);

			List<Misurazione> l = dati[x][y];
			if(l == null)
			{
				l = dati[x][y] = new ArrayList<Misurazione>();
			}
			l.add(m);
		}

		fileDati.close();
	}

	void elenco(Scanner stdin)
	{
		int xMax = dati.length;
		int yMax = dati[0].length;

		System.out.print("x? [0-" + (xMax-1) + "] > ");
		int x = Integer.parseInt(stdin.nextLine());
		System.out.print("y? [0-" + (yMax-1) + "] > ");
		int y = Integer.parseInt(stdin.nextLine());

		System.out.print("Come li ordino [giorno/valore]? > ");
		String ordType = stdin.nextLine();

		/*
		if(ordType.equals("giorno"))
		{
		}
		else if(ordType.equals("valore"))
		{
		}
		else
		{
			System.out.println("Ordinamento <" + ordType + "> non disponibile");
			return;
		}
		*/

		Comparator<Misurazione> c = comparatori.get(ordType);
		if(c == null)
		{
			System.out.println("Ordinamento <" + ordType + "> non disponibile");
			return;
		}

		Collections.sort(dati[x][y], c);
		System.out.println(dati[x][y]);
	}

	void minimo(Scanner stdin)
	{
		double max = Double.MIN_VALUE;
		int x = -1;
		int y = -1;
		short giorno = -1;

		int i,j;
		for(i=0;i<dati.length;i++)
		{
			for(j=0;j<dati[i].length;j++)
			{
				if(dati[i][j] == null)
				{
					continue;
				}
				ListIterator<Misurazione> li = dati[i][j].listIterator();
				while(li.hasNext())
				{
					Misurazione m = li.next();
					if(m.val > max)
					{
						max = m.val;
						x = i;
						y = j;
						giorno = m.giorno;
					}
				}
			}
		}
		System.out.println("Il valore massimo di radiazione " + max + " e' stato misurato in posizione " + x + " " + y + " il giorno " + giorno);
	}
}
